<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderStatusForShop StructType
 * @subpackage Structs
 */
class OrderStatusForShop extends AbstractStructBase
{
    /**
     * The statusID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $statusID;
    /**
     * The statusName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $statusName;
    /**
     * The statusENGName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $statusENGName;
    /**
     * The ReasonRrefusal
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReasonRrefusal;
    /**
     * The CarNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CarNumber;
    /**
     * The DriverPhone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DriverPhone;
    /**
     * Constructor method for OrderStatusForShop
     * @uses OrderStatusForShop::setStatusID()
     * @uses OrderStatusForShop::setStatusName()
     * @uses OrderStatusForShop::setStatusENGName()
     * @uses OrderStatusForShop::setReasonRrefusal()
     * @uses OrderStatusForShop::setCarNumber()
     * @uses OrderStatusForShop::setDriverPhone()
     * @param int $statusID
     * @param string $statusName
     * @param string $statusENGName
     * @param string $reasonRrefusal
     * @param string $carNumber
     * @param string $driverPhone
     */
    public function __construct($statusID = null, $statusName = null, $statusENGName = null, $reasonRrefusal = null, $carNumber = null, $driverPhone = null)
    {
        $this
            ->setStatusID($statusID)
            ->setStatusName($statusName)
            ->setStatusENGName($statusENGName)
            ->setReasonRrefusal($reasonRrefusal)
            ->setCarNumber($carNumber)
            ->setDriverPhone($driverPhone);
    }
    /**
     * Get statusID value
     * @return int
     */
    public function getStatusID()
    {
        return $this->statusID;
    }
    /**
     * Set statusID value
     * @param int $statusID
     * @return \StructType\OrderStatusForShop
     */
    public function setStatusID($statusID = null)
    {
        // validation for constraint: int
        if (!is_null($statusID) && !(is_int($statusID) || ctype_digit($statusID))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusID, true), gettype($statusID)), __LINE__);
        }
        $this->statusID = $statusID;
        return $this;
    }
    /**
     * Get statusName value
     * @return string|null
     */
    public function getStatusName()
    {
        return $this->statusName;
    }
    /**
     * Set statusName value
     * @param string $statusName
     * @return \StructType\OrderStatusForShop
     */
    public function setStatusName($statusName = null)
    {
        // validation for constraint: string
        if (!is_null($statusName) && !is_string($statusName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusName, true), gettype($statusName)), __LINE__);
        }
        $this->statusName = $statusName;
        return $this;
    }
    /**
     * Get statusENGName value
     * @return string|null
     */
    public function getStatusENGName()
    {
        return $this->statusENGName;
    }
    /**
     * Set statusENGName value
     * @param string $statusENGName
     * @return \StructType\OrderStatusForShop
     */
    public function setStatusENGName($statusENGName = null)
    {
        // validation for constraint: string
        if (!is_null($statusENGName) && !is_string($statusENGName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusENGName, true), gettype($statusENGName)), __LINE__);
        }
        $this->statusENGName = $statusENGName;
        return $this;
    }
    /**
     * Get ReasonRrefusal value
     * @return string|null
     */
    public function getReasonRrefusal()
    {
        return $this->ReasonRrefusal;
    }
    /**
     * Set ReasonRrefusal value
     * @param string $reasonRrefusal
     * @return \StructType\OrderStatusForShop
     */
    public function setReasonRrefusal($reasonRrefusal = null)
    {
        // validation for constraint: string
        if (!is_null($reasonRrefusal) && !is_string($reasonRrefusal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reasonRrefusal, true), gettype($reasonRrefusal)), __LINE__);
        }
        $this->ReasonRrefusal = $reasonRrefusal;
        return $this;
    }
    /**
     * Get CarNumber value
     * @return string|null
     */
    public function getCarNumber()
    {
        return $this->CarNumber;
    }
    /**
     * Set CarNumber value
     * @param string $carNumber
     * @return \StructType\OrderStatusForShop
     */
    public function setCarNumber($carNumber = null)
    {
        // validation for constraint: string
        if (!is_null($carNumber) && !is_string($carNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carNumber, true), gettype($carNumber)), __LINE__);
        }
        $this->CarNumber = $carNumber;
        return $this;
    }
    /**
     * Get DriverPhone value
     * @return string|null
     */
    public function getDriverPhone()
    {
        return $this->DriverPhone;
    }
    /**
     * Set DriverPhone value
     * @param string $driverPhone
     * @return \StructType\OrderStatusForShop
     */
    public function setDriverPhone($driverPhone = null)
    {
        // validation for constraint: string
        if (!is_null($driverPhone) && !is_string($driverPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($driverPhone, true), gettype($driverPhone)), __LINE__);
        }
        $this->DriverPhone = $driverPhone;
        return $this;
    }
}
